#!/bin/sh
#
#  DEFAULT KDE STARTUP SCRIPT ( KDE-2.2.2 )
#

# Boot sequence:
#
# kdeinit is used to fork off processes which improves memory usage
# and startup time.
#
# * kdeinit starts the dcopserver and klauncher first.
# * Then kded is started. kded is responsible for keeping the sycoca
#   database up to date. When an up to date database is present it goes
#   into the background and the startup continues.
# * Then kdeinit starts kcminit. kcminit performs initialisation of
#   certain devices according to the user's settings
#
# * Then ksmserver is started which in turn starts 
#   1) the window manager (kwin)
#   2) everything in $KDEDIR/share/autostart (kdesktop, kicker, etc.)
#   3) the rest of the session.

# Set a left cursor instead of the standard X11 "X" cursor, since I've heard
# from some users that they're confused and don't know what to do. This is
# especially necessary on slow machines, where starting KDE takes one or two
# minutes until anything appears on the screen.
#
# Set the background to plain grey.
# The standard X background is nasty, causing more effects and exploding
# people's heads. We use colours from the standard KDE palette for those with
# palettised displays.

test "$XDM_MANAGED" || bkg="-solid #C0C0C0"
xsetroot -cursor_name left_ptr $bkg

# The user's personal KDE directory is usually $HOME/.kde, but this setting
# may be overridden by setting KDEHOME.

kdehome=$HOME/.kde
test -n "$KDEHOME" && kdehome=$KDEHOME

# Activate the kde font directories.
#
# There are 4 directories that may be used for supplying fonts for KDE.
#
# There are two system directories. These belong to the administrator.
# There are two user directories, where the user may add her own fonts.
#
# The 'override' versions are for fonts that should come first in the list,
# i.e. if you have a font in your 'override' directory, it will be used in
# preference to any other.
#
# The preference order looks like this:
# user override, system override, X, user, system
#
# Where X is the original font database that was set up before this script
# runs.

#usr_odir=$kdehome/share/fonts/override
#usr_fdir=$kdehome/share/fonts
#if test -n "$KDEDIRS"; then
#  kdedirs_first=`echo $KDEDIRS|sed -e 's/:.*//'`
#  sys_odir=$kdedirs_first/share/fonts/override
#  sys_fdir=$kdedirs_first/share/fonts
#else
#  sys_odir=$KDEDIR/share/fonts/override
#  sys_fdir=$KDEDIR/share/fonts
#fi

# We run mkfontdir on the user's font dirs (if we have permission) to pick
# up any new fonts they may have installed. If mkfontdir fails, we still
# add the user's dirs to the font path, as they might simply have been made
# read-only by the administrator, for whatever reason.

#test -d $usr_odir && (mkfontdir $usr_odir ; xset +fp $usr_odir)
#test -d $sys_odir && xset +fp $sys_odir
#test -d $usr_fdir && (mkfontdir $usr_fdir ; xset fp+ $usr_fdir)
#test -d $sys_fdir && xset fp+ $sys_fdir

# Ask X11 to rebuild its font list.
#xset fp rehash

# Link "tmp" resource to directory in /tmp
# Creates a directory /tmp/kde-$USER and links $KDEHOME/tmp-$HOSTNAME to it.
lnusertemp tmp >/dev/null

# Link "socket" resource to directory in /tmp
# Creates a directory /tmp/ksocket-$USER and links $KDEHOME/socket-$HOSTNAME to it.
lnusertemp socket >/dev/null

# the splashscreen and progress indicator
ksplash

# We set LD_BIND_NOW to increase the efficiency of kdeinit.
# kdeinit unsets this variable before loading applications.
LD_BIND_NOW=true kdeinit +kcminit +knotify

# finally, give the session control to the session manager
# Syntax:   ksmserver [--restore] [--windowmanager <wm>]
# if no windowmanager is specified, ksmserver will ensure kwin is started.
# [--restore] should be controlled by kdm
ksmserver --restore
# Clean up
kdeinit_shutdown
